<div class="loadOverlay" *ngIf="(popService.isLoading$ | async) || (this.isLoading$ | async)">
  <mat-spinner [diameter]="50"></mat-spinner>
</div>
<app-header-card [title]="'Einwohnerdaten der Vergangenheit (Realdaten)'"
                 cookieId="exp-realdata-header"
                 width="1170px">
  <p>Für die Abschätzung der Nachfrage nach Infrastrukturen werden u.a. Einwohnerdaten benötigt. Auf dieser Seite können Sie Daten zur Einwohnerzahl und Altersstruktur in den zurückliegenden Jahren einlesen. Prognosedaten werden über den Eingabeseite „Zukunft“ (nächster Punkte im Menü links) eingepflegt.</p>
  <p>Die Einwohnerdaten werden für die Gebietsebene eingelesen, die Sie im obersten Menüpunkt „Gebietseinteilungen“ hierfür ausgewählt haben. Standardmäßig ist dies die Gemeindeebene. Einwohnerdaten anderer Gebietseinteilungen (z.B. Kreise oder Verwaltungsgemeinschaften) werden aus diesen Daten automatisch abgeleitet.</p>
  <p>Sie können Einwohnerdaten für Ihren Planungsraum online vom zentralen Datendienst „Regionalstatistik“ der Statistikämter des Bundes und der Länder abrufen und diese Daten bei Bedarf händisch ergänzen.</p>
  <p>Bereits abgerufene oder hochgeladene Einwohnerdaten können Sie über die Karte sowie das Alterspyramiden-Diagramm kontrollieren. Zudem können Sie sich alle Daten in einer Tabellenansicht anzeigen lassen.</p>
  <p>Die auf dieser Seite zusammengetragenen Einwohnerdaten sind für alle Nutzer:innen im Hauptmenübereich „Bevölkerung“ sichtbar. Zudem stehen sie für Auswertungen im Hauptmenübereich „Infrastrukturplanung“ zur Verfügung.</p>
</app-header-card>
<app-status-card *ngIf="!(popService.isLoading$ | async) && years.length === 0" [showSpinner]="false"
                 infoText="Im Bereich „Administration“ > „Basisdefinitionen“ muss ein Betrachtungszeitraum definiert werden.">
  Fehler: Es ist kein Betrachtungszeitraum festgelegt!
</app-status-card>
<app-status-card *ngIf="!(popService.isLoading$ | async) && !popLevel" [showSpinner]="false"
                 infoText="Bitte legen Sie im Bereich „Gebietseinteilungen“ eine Gebietseinteilung für die Einwohnerdaten fest.">
  Fehler: Es ist keine Gebietseinteilung für die Bevölkerungsdaten festgelegt!
</app-status-card>
<app-status-card *ngIf="popLevel?.areaCount === 0" [showSpinner]="false"
                 infoText="Bitte laden Sie im Bereich „Gebietseinteilungen“ Gebiete für die Gebietseinteilung hoch bzw. rufen Sie sie ab.">
  Fehler: Die Gebietseinteilung für die Bevölkerungsdaten („{{popLevel?.name}}“)  enthält keine Gebiete!
</app-status-card>
<app-status-card *ngIf="(isProcessing$ | async)">
  Es läuft gerade eine Berechnung im Bereich „Bevölkerung“
</app-status-card>
<div fxLayout="row wrap">
  <app-input-card [title]="'Einwohnerdaten online abrufen'"
                  width="300px"
                  infoText="<p>Mit einem Klick auf die Schaltfläche „Abrufen“ können Sie Einwohnerdaten für Ihren Planungsraum online vom zentralen Datendienst „Regionalstatistik“ der Statistikämter des Bundes und der Länder abrufen. Der Zugriff ist kostenlos, er kann jedoch einige Minuten dauern.</p>
                  <p>Der Fortschritt der Abfrage wird Ihnen in der Box „Datenhistorie“ angezeigt. Die eingelesenen Daten können Sie anschließend in der Box „Bereits eingelesene Daten“ als Tabelle, Karte oder Diagramm betrachten.</p>
                  <p>Der Online-Abruf steht nur zur Verfügung, wenn die Einteilung der Altersgruppen im Administrationsbereich nicht gegenüber der Standardeinstellung (Alterseinteilung der Regionalstatistik) verändert wurde.</p>"
                  [subtitle]="'Abruf der Regionalstatistik'"
                  [disabled]="(isProcessing$ | async) || years.length === 0 || !popLevel || !popLevel.isDefaultPopLevel || popLevel.areaCount === 0">
    <ng-container *ngIf="!(popService.isLoading$ | async)">
      <ng-container *ngIf="popLevel && popLevel.isDefaultPopLevel && ageGroupsRegStatValid; else notAvailable">
        <label>
          <ng-container *ngIf="(this.settings.siteSettings$ | async)?.regionalstatistikUser else noRegStatUser">
            Nutzerdaten für die Regionalstatistik sind hinterlegt
          </ng-container>
          <ng-template #noRegStatUser>
            Es sind keine Nutzerdaten für die Regionalstatistik hinterlegt
          </ng-template>
        </label>
        <div style="margin-top: 10px">
          <button mat-flat-button color="primary"
                  (click)="pullService()">
            <mat-icon>refresh</mat-icon> Abrufen
          </button>
        </div>
      </ng-container>
    </ng-container>
    <ng-template #notAvailable>Die Regionalstatistik kann nur abgerufen werden, wenn "{{defaultPopLevel?.name}}" als Gebietseinteilung für alle Einwohnerdaten ausgewählt wurde (siehe Grundlagendaten > Gebietseinteilungen) und die Altersgruppeneinteilung mit der Regionalstatistik übereinstimmt (siehe Administration > Basisdefinitionen).</ng-template>
  </app-input-card>
  <div fxFlex="450px">
    <app-input-card #yearCard
                    [title]="'Jahre mit Vergangenheitsdaten'"
                    subtitle="Folgende Jahre sollen in Vorlage und Karten enthalten sein"
                    [editTemplate]="yearsEdit"
                    infoText="<p>Die Liste zeigt die Jahre, deren Einwohnerdaten den Nutzer:innen der Hauptmenübereiche „Bevölkerung“ und „Infrastrukturplanung“ als Vergangenheitsdaten angezeigt werden.</p>
                    <p>Klicken Sie auf „Editieren“, um die Auswahl zu verändern und mit dem Datenbestand abzugleichen. Weitere Erläuterungen finden Sie im Hilfetext des sich dann öffnenden Dialogfensters.</p>
                    <p>Über die Schaltfläche „Editieren“ können Sie auch bereits online abgefragte oder händisch hochgeladene Daten einzelner Jahre wieder löschen.</p>"
                    dialogInfoText="<p>Die Liste enthält alle zurückliegenden Jahre Ihres Betrachtungszeitraums. In der mittleren Spalte sind die Jahre mit einem grauen Häkchen markiert, für die „reale“ (d.h. nicht prognostizierte) Einwohnerdaten vorliegen – sei es aus dem Online-Abruf oder den von Ihnen händisch hochgeladenen Daten.</p>
                    <p>Sie können in der ersten Spalte auswählen, welche dieser Daten Sie den Nutzer:innen der Hauptmenübereiche „Bevölkerung“ und „Infrastrukturplanung“ als Vergangenheitsdaten anzeigen möchten. </p>
                    <p>Besonders relevant ist diese Auswahl, wenn in einem Jahr sowohl Realdaten aus der Einwohnerstatistik wie auch Prognosedaten aus einer ggf. schon etwas älteren Prognose vorliegen. Daher zeigt Ihnen die letzte Spalte an, für welche der zurückliegenden Jahre auch Prognosedaten in daviplan hochgeladen wurden.</p>
                    <p>Um bereits hochgeladene reale Einwohnerdaten zurückliegender Jahre wieder zu löschen, klicken Sie auf das entsprechende rote Kreuzchen in der Spalte „Realdaten“. Prognosedaten löschen Sie über den Menüpunkt „Bevölkerung > Zukunft“ im Menü am linken Browserrand.</p>"
                    dialogWidth="500px"
                    [disabled]="(isProcessing$ | async) || years.length === 0 || !popLevel">
      <table>
        <tr>
          <td i18n>Jahre</td>
          <td>
            <ng-container *ngIf="realYears.length === 0">-</ng-container>
            <ng-container *ngFor="let year of realYears; let i = index;">
              {{year}}<ng-container *ngIf="i !== realYears.length - 1">, </ng-container>
            </ng-container>
          </td>
        </tr>
      </table>
    </app-input-card>
    <app-input-card [title]="'Ergänzte/korrigierte Einwohnerdaten hochladen'"
                    [disabled]="(isProcessing$ | async) || years.length === 0 || realYears.length === 0 || !popLevel || popLevel.areaCount === 0"
                    infoText="<p>Sollten Sie Lücken in den Daten finden, einzelne Werte korrigieren wollen oder keine Daten online abrufen können oder wollen, können Sie Einwohnerdaten auch händisch eingeben.</p>
                    <p>Laden Sie sich hierzu über die Schaltfläche „Vorlage herunterladen“ eine Excel-Vorlage herunter. Diese enthält alle bereits per Online-Abruf oder frühere Eintragungen bereits in daviplan verfügbaren Einwohnerdaten. Um eine Vorlage zu erzeugen, muss die Liste „Jahre mit Vergangenheitsdaten” mindestens ein Jahr beinhalten.“</p>
                    <p>Öffnen Sie die heruntergeladene Vorlage in Excel und nehmen Sie dort Ihre Eintragungen vor. Laden Sie anschließend immer diese gesamte Vorlage inkl. Ihrer Änderungen hoch.</p>
                    <p>Um der Vorlage ein weiteres Jahr hinzufügen, für das Ihnen bereits Vergangenheitsdaten vorliegen (aber die ggf. noch nicht im online-Abruf verfügbar ist), klicken Sie bitte auf die Schaltfläche „Editieren“ in der Eingabebox „Jahre“, wählen dort das betreffende Jahr aus und laden anschließend hier die Vorlage – ggf. erneut – herunter.</p>">
      <span *ngIf="realYears.length === 0" style="margin-bottom: 10px;">
        Es müssen „Jahre mit Vergangenheitsdaten“ ausgewählt werden, damit eine Vorlage mit diesen Jahren erzeugt werden kann.
      </span>
      <div style="width: 100%; display: flex;">
        <button mat-stroked-button color="primary" style="margin-right: 10px;"
                (click)="downloadTemplate()">
          <mat-icon>download</mat-icon> Vorlage herunterladen
        </button>
        <button mat-flat-button color="primary"
                (click)="uploadTemplate()">
          <mat-icon>upload</mat-icon> Daten hochladen
        </button>
      </div>
    </app-input-card>
  </div>
  <app-input-card subtitle="Daten-Historie Bevölkerung"
                  infoText="<p>Die Liste zeigt Ihnen eine Chronik aller Datenimporte (Online-Abfragen und Hochladen befüllter Vorlagen) und Berechnungen im Bereich „Bevölkerung“.</p>"
                  width="400px">
    <app-log room="population" (onMessage)="onMessage($event)" height="350px"></app-log>
  </app-input-card>
</div>
<div fxLayout="row wrap">
  <app-input-card [title]="'Bereits importierte Einwohnerdaten'"
                  [topRightHelp]="true"
                  width="1170px"
                  [disabled]="(isProcessing$ | async) || years.length === 0 || !popLevel || popLevel.areaCount === 0"
                  infoText="<p>Sie haben drei Möglichkeiten, sich die bereits importierten Einwohnerdaten der zurückliegenden Jahre anzusehen.</p>
                  <ol type='1'>
                    <li>Sie können sich alle Daten in einer Tabellenansicht ansehen</li>
                    <li>Sie können ein Jahr auswählen und sich die Gesamteinwohnerzahl aller Gebiete in der Karte ansehen. Diese können Sie über die Kartensteuerung auch als Vollbild über den gesamten Bildschirm anzeigen lassen. Die Namen der Gebiete werden Ihnen angezeigt, wenn Sie mit der Maus über die Karte fahren.</li>
                    <li>Wenn Sie ein Gebiet in der Karte anklicken wird Ihnen die Alterspyramide nach Geschlecht für das Jahr der Kartendarstellung angezeigt. Alternativ können Sie das Gebiet auch über die darüberstehende Auswahlliste wählen.</li>
                  </ol>
                  <p>Voraussetzung für alle Anzeigen ist, dass Sie bereits Einwohnerdaten für mindestens ein Jahr hochgeladen und haben und mindestens ein Jahr zur Anzeige ausgewählt wurde.</p>">
    <div style="margin-bottom: 10px;">
      <button class="mat-button-dv"
              mat-button color="primary"
              (click)="showDataTable()">
        <mat-icon class="material-icons-outlined">table_chart</mat-icon>
        Alle Daten (als Tabelle)
      </button>
    </div>
    <div style="width: 100%; display: flex;">
      <div style="width: 50%; margin-right: 10px;">
        <span class="subtitle1">Alle Gesamtwerte eines Jahres</span><br>
        <mat-form-field appearance="outline" class="small" style="margin-right: 10px;">
          <mat-label>Jahr</mat-label>
          <mat-select disableOptionCentering disableRipple
                      [(ngModel)]="previewYear"
                      (ngModelChange)="updatePreview()">
            <ng-container *ngFor="let year of years">
              <mat-option *ngIf="year.isReal" [value]="year">
                {{year.year}}
              </mat-option>
            </ng-container>
          </mat-select>
        </mat-form-field>
        <div id="base-real-data-map" class="map-container">
          <app-map-controls target="base-real-data-map"></app-map-controls>
          <app-side-toggle *ngIf="popLevel"
                           id="legend"
                           icon="layers"
                           name="Legenden- und Layersteuerung"
                           direction="left">
            <app-legend *ngIf="popLevel"
                        target="base-real-data-map"></app-legend>
          </app-side-toggle>
        </div>
      </div>
      <div style="width: 50%">
        <span class="subtitle1">Altersstruktur eines Gebiets in diesem Jahr</span><br>
        <mat-form-field appearance="outline" class="small">
          <mat-label>Gebiet</mat-label>
          <mat-select disableOptionCentering disableRipple
                      [(ngModel)]="previewArea"
                      (ngModelChange)="onAreaChange()">
            <mat-option *ngFor="let area of areas" [value]="area">
              {{area.properties.label}}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <div class="diagram-wrapper">
          <app-age-tree #ageTree
                        [showPNGExport]="true"
                        [animate]="true"
                        [title]="'Bevölkerungspyramide'">
          </app-age-tree>
        </div>
      </div>
    </div>
  </app-input-card>
</div>

<ng-template #yearsEdit>
  <table id="years-check-table">
    <tr>
      <th colspan="2"></th>
      <th colspan="2">Daten in der Datenbank</th>
    </tr>
    <tr>
      <th style="text-align: left;">Jahr</th>
      <th>Jahr anzeigen</th>
      <th>Realdaten</th>
      <th>Prognosedaten</th>
    </tr>
    <tr *ngFor="let year of years" [class.active]="yearSelection.isSelected(year.year)">
      <td [title]="yearSelection.isSelected(year.year)? year.year + ' (Realdatenjahr)': year.year">
        {{year.year}}
      </td>
      <td>
        <mat-checkbox color="primary"
                      [checked]="yearSelection.isSelected(year.year)"
                      (change)="yearSelection.toggle(year.year)"
                      [disabled]="year.year > maxYear"
                      title="{{year.year}} als Realdatenjahr aus/abwählen">
        </mat-checkbox>
      </td>
      <td style="text-align: right;">
        <mat-checkbox [disabled]="true"
                      [checked]="year.hasRealData"
                      title="Zeigt an, ob für das Jahr bereits Bevölkerungsdaten vorliegen">
        </mat-checkbox>
        <button [style.opacity]="(!year.hasRealData)? 0: 1"
                [style.pointer-events]="(!year.hasRealData)? 'none': ''"
                (click)="deleteData(year)"
                mat-icon-button color="warn"
                title="Realdaten des Jahres {{year.year}} entfernen"
                style="margin-left: 3px;">
          <mat-icon>close</mat-icon>
        </button>
      </td>
      <td>
        <mat-checkbox [disabled]="true"
                      [checked]="year.hasPrognosisData"
                      title="Zeigt an, ob für das Jahr bereits Prognosedaten vorliegen">
        </mat-checkbox>
      </td>
    </tr>
  </table>
</ng-template>

<ng-template #pullServiceTemplate>
  <p>
    Sollen die Einwohnerdaten aus der Regionalstatistik jetzt abgerufen und als Realdaten in die Datenbank eingespielt werden?
  </p>
  <p>
    Achtung: bereits eingespielte Realdaten werden überschrieben!
  </p>
</ng-template>

<ng-template #dataTemplate>
  <div class="loadOverlay" *ngIf="isLoading$ | async">
    <mat-spinner [diameter]="50"></mat-spinner>
  </div>
  <mat-form-field appearance="outline" class="small" style="margin-right: 10px;">
    <mat-label>Jahr</mat-label>
    <mat-select disableOptionCentering disableRipple
                [(ngModel)]="dataTableYear"
                (ngModelChange)="updateTableData()">
      <ng-container *ngFor="let year of years">
        <mat-option *ngIf="year.isReal" [value]="year">
          {{year.year}}
        </mat-option>
      </ng-container>
    </mat-select>
  </mat-form-field>
  <app-data-table [columns]="dataTableColumns" [rows]="dataTableRows"></app-data-table>
</ng-template>

<ng-template #fileUploadTemplate>
  <p>
    Ergänzte Excel-Vorlage mit Vergangenheitsdaten hochladen
  </p>
  <input #fileInput type="file" accept=".xlsx,.xls" (change)="setFiles($event)">
</ng-template>
